// vMac 0.x Source
// By Philip Cummins (PC)
// Copyright PC 1997

// PC - ROM Function Files

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "ROM.h"
#include "prefs.h"
#ifdef _ROM_Debug
#include <stdio.h>
#endif

UWORD ROM[kROM_Size / 2];

int ROM_Init(void)
{
    FILE *ROM_File;
    int File_Size;
    int i;

    ROM_File = fopen(thePrefs.ROMPath[thePrefs.CurrentROMPath], "rb");
    if (ROM_File == NULL)
	ROM_File = fopen("vMac.ROM", "rb");

    if (ROM_File == NULL) {

#ifdef _MacOS
	ParamText("\pThe vMac.ROM could not be found.", "\p", "\p", "\p");
#else
	printf("The vMac.ROM could not be found.\n");
#endif
	return 1;
    }
    File_Size = fread(ROM, kROM_Size, 1, ROM_File);
    printf("Loading vMac.ROM...\n");
    if (File_Size != 1) {
#ifdef _MacOS
	ParamText("\pThe vMac.ROM is not 128 KB.", "\p", "\p", "\p");
#else
	printf("The vMac.ROM is not 128 KB.\n");
#endif
	fclose(ROM_File);
	return 1;
    }
    fclose(ROM_File);
#if FIXEND
    for (i = 0; i < kROM_Size / 2; i++) {
	UWORD *p = ROM + i;
	UBYTE *bp = (UBYTE *) p;
	*p = (*bp << 8) | *(bp + 1);
    }
#endif
    if ((ROM[0] == 0x4D1E) && (ROM[1] == 0xEEE1)) {
	printf("vMac.ROM loaded successfully, Mac Plus ROM v 1, 'Lonely Hearts'.\n");
#ifdef _MacOS
	MacOS_CopyPString("\pvMac - Macintosh Plus - ROM v1 - 'Lonely Hearts'", windowTitleStr);
#endif
	return 0;
    }
    if ((ROM[0] == 0x4D1E) && (ROM[1] == 0xEAE1)) {
	printf("vMac.ROM loaded successfully, Mac Plus ROM v 2, 'Lonely Heifers'.\n");
#ifdef _MacOS
	MacOS_CopyPString("\pvMac - Macintosh Plus - ROM v2 - 'Lonely Heifers'", windowTitleStr);
#endif
	return 0;
    }
    if ((ROM[0] == 0x4D1F) && (ROM[1] == 0x8172)) {
	printf("vMac.ROM loaded successfully, Mac Plus ROM v 3, 'Loud Harmonicas'.\n");
#ifdef _MacOS
	MacOS_CopyPString("\pvMac - Macintosh Plus - ROM v3 - 'Loud Harmonicas'", windowTitleStr);
#endif
	return 0;
    }
#ifdef _MacOS
    ParamText("\pvMac.ROM loaded successfully, but we don't support this ROM yet.", "\p", "\p", "\p");
#else
    printf("vMac.ROM loaded successfully, but we don't support this ROM yet.\n");
#endif
    return 1;
}

void ROM_Reset(void)
{
    extern UBYTE Sony_Installed;

    if (Sony_Installed == 1)
	(void) ROM_Init();
}

UWORD *ROM_Xlate(CPTR addr)
{
    return ROM + (addr >> 1);
}

UBYTE ROM_GetB(CPTR addr)
{
    return ROM[addr >> 1] >> (addr & 1 ? 0 : 8);
}

UWORD ROM_GetW(CPTR addr)
{
    return ROM[addr >> 1];
}

ULONG ROM_GetL(CPTR addr)
{
    return ((ULONG) ROM[addr >> 1] << 16) | ROM[(addr >> 1) + 1];
}

void ROM_PutB(CPTR addr, UBYTE in)
{
    NULL;
}

void ROM_PutW(CPTR addr, UWORD in)
{
    NULL;
}

void ROM_PutL(CPTR addr, ULONG in)
{
    NULL;
}
