#
# Makefile for vMac
#

CC=gcc
CFLAGS=-DFIXEND -D__inline__=inline -g
#CFLAGS=-DFIXEND -D__inline__=inline -Wall -Wno-unused -Wno-format -W -Wmissing-prototypes -Wstrict-prototypes -g

.SUFFIXES: .o .c .h .m

INCLUDES=-I./Includes -I./Hardware -I/usr/X11R6/include -I/usr/include -I.

OBJS = cpudefs.o custom.o main.o newcpu.o readcpu.o debug.o prefs.o \
       Hardware/IWM.o Hardware/Keyboard.o Hardware/Memory.o Hardware/Mouse.o \
       Hardware/Native.o Hardware/RAM.o Hardware/ROM.o Hardware/RTC.o \
       Hardware/SCC.o Hardware/SCSI.o Hardware/Sony.o Hardware/Sound.o \
       Hardware/VIA.o Hardware/VIA_Interrupts.o Hardware/VIA_Interface.o \
       Unix/Screen-X.o \
       CPU_Sources/cpu0.o CPU_Sources/cpu1.o CPU_Sources/cpu2.o \
       CPU_Sources/cpu3.o CPU_Sources/cpu4.o CPU_Sources/cpu5.o \
       CPU_Sources/cpu6.o CPU_Sources/cpu7.o CPU_Sources/cpu8.o \
       CPU_Sources/cpu9.o CPU_Sources/cpuA.o CPU_Sources/cpuB.o \
       CPU_Sources/cpuC.o CPU_Sources/cpuD.o CPU_Sources/cpuE.o \
       CPU_Sources/cpuF.o CPU_Sources/cpustbl.o

all: vMac

vMac: $(OBJS)
	$(CC) $(OBJS) -o vMac -L/usr/X11R6/lib -lX11

clean:
	rm -f *.o
	rm -f Hardware/*.o
	rm -f Unix/*.o
	rm -f CPU_Sources/*.o
	rm -f vMac

halfclean:
	rm -f *.o
	rm -f Hardware/*.o
	rm -f Unix/*.o
	rm -f CPU_Sources/*.o


CPU_Sources/cpu0.o: CPU_Sources/cpu0.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu1.o: CPU_Sources/cpu1.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu2.o: CPU_Sources/cpu2.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu3.o: CPU_Sources/cpu3.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu4.o: CPU_Sources/cpu4.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu5.o: CPU_Sources/cpu5.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu6.o: CPU_Sources/cpu6.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu7.o: CPU_Sources/cpu7.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu8.o: CPU_Sources/cpu8.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpu9.o: CPU_Sources/cpu9.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpuA.o: CPU_Sources/cpuA.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpuB.o: CPU_Sources/cpuB.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpuC.o: CPU_Sources/cpuC.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpuD.o: CPU_Sources/cpuD.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpuE.o: CPU_Sources/cpuE.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
CPU_Sources/cpuF.o: CPU_Sources/cpuF.c CPU_Sources/cputbl.h
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@

.m.o:
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.m
.c.o:
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.c -o $@
.c.s:
	$(CC) $(INCLUDES) -S $(CFLAGS) $*.c
.c.i:
	$(CC) $(INCLUDES) -E $(CFLAGS) $*.c > $@
.S.o:
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.S
.s.o:
	$(CC) $(INCLUDES) -c $(CFLAGS) $*.s
