/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */
   
#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "memory.h"
#include "custom.h"
#include "newcpu.h"
#include "debug.h"
#include "prefs.h"
#include "Sony.h"

int use_debugger = 0;

void Quit_vMac(void);

void Quit_vMac(void)
{
	#ifdef _MacOS
		PrefsSave("vMac Prefs");
	#else
		PrefsSave("vMac.cfg");
	#endif
	 
	#ifdef _MacOS
		ShowCursor();
		MacOS_ShowMenuBar();
		FlushEvents(everyEvent,0);
		ExitToShell();
	#endif
}

void main(int argc, char **argv)
{
    #ifdef FIXEND
	#ifdef _Debug
	if (argc > 1)
	  if (strcasecmp(argv[1], "-d") == 0)
	    use_debugger = 1;
	#endif
	#endif
	#ifdef _MacOS
		PrefsLoad("vMac Prefs");
		MacOS_Init();
	#else
		PrefsLoad("vMac.cfg");
	#endif

	init_m68k();

	if (custominit() == 0)
	{
		MC68000_reset();
		
		#ifdef _MacOS
			MacOS_MacPlusBeep();
		#endif
    
		#ifdef _Debug
		#ifdef DJGPP
			if (use_debugger) { extern void EnterDebug(void); EnterDebug(); }
		#endif
			debug();
		#else
			MC68000_run();
		#endif
	}
	else
	{
		#ifdef _MacOS
			// The text for this alert has already been primed.
			Alert(129,0L);
		#else
			printf("Sorry, vMac encountered errors and cannot continue.\n");
		#endif
	}
	
	#ifdef _MacOS
		PrefsSave("vMac Prefs");
	#else
		PrefsSave("vMac.cfg");
	#endif
}

#ifdef _MacOS
	#include "Main_MacOS.i"
#endif
